<template lang='pug'>
BaseDialog.x-create-relation-dialog(ref='dialog' title='Add Relation')
  template(v-if='query')
    BaseAnimationGroup.row.justify-content-center(anim="height")
      .col-12(key='query')
        .input-group.input-group-sm
          .input-group-prepend
            button.text-monospace.btn.btn-secondary(type='button' disabled='1') query-selector
          span.form-control.text-truncate.right.text-monospace.shadow-none(type='text' readonly='1' :value='query') {{ query }}
      .col-12(key='type')
        Input.p-0(ref='type' name='type' :inEdit='true')
          select.x-type(v-model='type')
            option(v-for='t, k in $options.types' :disabled='t.isAvailable && !t.isAvailable(selection)'
                :key='k' :value='k' :selected="type === k") {{ t.name }}
      .col-12(key='typeCustom' v-if='type === "custom"')
        .row
          .col-12
            Input.p-0(ref='attribute-name' name='attribute-name' :inEdit='true' @edit='checkValidity')
              template(#default='d')
                datalist(:id='svgAttributesId')
                  option opacity
                  option width
                  option height
                  option color
                  option background-color
                  option offset
                  option cx
                  option cy
                  option r
                  option radius
                  option rx
                  option ry
                  option rotate
                  option dx
                  option dy
                  option fill
                  option fill-opacity
                  option stroke
                  option stroke-width
                  option scale
                  option x
                  option y
                  option z
                input(type='text' v-model='d.$data.editValue' :list='svgAttributesId')
          .col-12.col-md-6
            Input.p-0(ref='attribute-type' name='attribute-type' :inEdit='true')
              template(#default='d')
                select(v-model='d.$data.editValue')
                  option(value='' selected='1') (no set)
                  option(value='auto') auto
                  option(value='CSS') CSS
                  option(value='XML') XML
          .col-12.col-md-6
            Input.p-0(ref='calc-mode' name='calc-mode' :inEdit='true')
              template(#default='d')
                select(v-model='d.$data.editValue')
                  option(value='' selected='1') (no set)
                  option(value='linear') linear
                  option(value='discrete') discrete
          .col-6
            Input.p-0(ref='from' name='from' :inEdit='true')
              template(#default='d')
                input(type='text' v-model='d.$data.editValue')
          .col-6
            Input.p-0(ref='to' name='to' :inEdit='true' @edit='checkValidity')
              template(#default='d')
                input(type='text' v-model='d.$data.editValue' required='1')
      .col-12(key='typeColor' v-if='type === "color"')
        .row
          .col-6
            Input.p-0(ref='from' name='from' :inEdit='true')
              template(#default='d')
                  input(type='color' v-model='d.$data.editValue')
          .col-6
            Input.p-0(ref='to' name='to' value='#FFFFFF' :inEdit='true')
              template(#default='d')
                input(type='color' v-model='d.$data.editValue')
      .col-12(key='typeOpacity' v-if='type === "opacity"')
        .row
          .col-6
            Input.p-0(ref='from' name='from' :inEdit='true' @edit='checkValidity')
              template(#default='d')
                  input(type='number' min='0' max='1' step='0.01' v-model='d.$data.editValue')
          .col-6
            Input.p-0(ref='to' name='to' :inEdit='true' @edit='checkValidity')
              template(#default='d')
                input(type='number' min='0' max='1' step='0.01' v-model='d.$data.editValue' required='1')
      .col-12(key='typeWidth' v-if='type === "width" || type === "height"')
        .row
          .col-6
            Input.p-0(ref='from' name='from' :inEdit='true')
              template(#default='d')
                  input(type='number' step='any' v-model='d.$data.editValue')
          .col-6
            Input.p-0(ref='to' name='to' :inEdit='true' @edit='checkValidity')
              template(#default='d')
                input(type='number' step='any' v-model='d.$data.editValue' required='1')

  template(v-slot:footer='d')
    button.btn.btn-secondary(@click='d.resolve(false)') Cancel
    button.btn.btn-primary(:disabled='!isValid' @click='d.resolve(true)') Create
</template>
<script src='./CreateRelationDialog.vue.js' />
<style lang="scss">
.x-create-relation-dialog {
  .row {
    align-items: flex-end !important;
  }
}
</style>
